#needsrootforbuild
%global __cargo_skip_build 0
%global _debugsource_packages 1
%global _debuginfo_subpackages 1
%define _unpackaged_files_terminate_build 0

Name:           stratovirt
Version:        2.1.0
Release:        8
Summary:        StratoVirt is an opensource VMM(Virtual Machine Manager) which aims to perform next generation virtualization.

License:        MulanPSL-2.0
URL:            https://gitee.com/openeuler/stratovirt
Source0:        https://gitee.com/openeuler/stratovirt/releases/download/v%{version}/%{name}-%{version}.tar.gz

Patch001: 0001-docs-update-the-document-remove-the-other-features-t.patch
Patch002: 0002-legacy-fwcfg-fix-bug-of-wrong-size-judgment.patch
Patch003: 0003-standard_vm-add-FACS-acpi-table-on-x86-plantform.patch
Patch004: 0004-docs-build_guide-Update-suggested-rustc-version.patch
Patch005: 0005-standard_vm-syscall-Add-new-seccomp-rules.patch
Patch006: 0006-Implement-a-safe-offset_of-macro-function.patch
Patch007: 0007-loop_context-fix-the-bug-that-parked-event-not-remov.patch
Patch008: 0008-migration-use-device-id-as-snapshot-id.patch
Patch009: 0009-tests-fix-the-test_standvm_quickstart.patch
Patch010: 0010-root_port-correct-the-log-of-printing-device-info-du.patch
Patch011: 0011-tests-add-stand-kata-testcases.patch
Patch012: 0012-net-fix-the-bug-when-tap-is-abnormally-removed.patch
Patch013: 0013-docs-boot-update-detailed-usage-for-standard-boot.patch
Patch014: 0014-virtio-queue-fix-error-access-queue-s-host-virtual-a.patch
Patch015: 0015-vfio-doc-create-a-new-document-for-using-vfio.patch
Patch016: 0016-docs-correct-the-command-for-booting-with-the-raw-im.patch
Patch017: 0017-pci-no-need-to-delete-the-unmapped-region.patch
Patch018: 0018-arm-use-the-HighPcieEcam-region.patch
Patch019: 0019-vfio-fix-hot-plug-the-same-device-multiple-times-pro.patch
Patch020: 0020-machine-update-seccomp-rules.patch
Patch021: 0021-console-fix-the-bug-of-delete-park-fd.patch
Patch022: 0022-docs-add-the-description-of-hot-plug-of-PCI-devices.patch
Patch023: 0023-Modify-cargo-cllippy-warning-when-compiling-cargo-cl.patch
Patch024: 0024-machine-clear-some-warnings.patch
Patch025: 0025-micro_vm-update-seccomp-rules.patch

ExclusiveArch:  x86_64 aarch64

%ifarch aarch64
Requires:      dtc
BuildRequires: dtc-devel
%endif

BuildRequires:  rust
BuildRequires:  cargo
BuildRequires:  rust-packaging
BuildRequires:  gcc

%description
Based on Rust programming language, StratoVirt is lightweight, efficient and safe. StratoVirt reduces memory resource consumption and improves VM startup speed while retains isolation capability and security capability of traditional virtualization. StratoVirt works with iSulad and Kata container, and can be integrated in Kubernetes ecosystem perfectly. The current version can be applied to microservices or serverless scenarios. StratoVirt reserves interface and design for importing more features, even standard virtualization.

Summary:        %{summary}

%files       -n stratovirt
%{_bindir}/stratovirt
%{_bindir}/ozone

%prep
%autosetup -p1

%cargo_prep

%cargo_generate_buildrequires

%build

%ifarch aarch64
sed -i '/\[build\]/a target="aarch64-unknown-linux-musl"' ./.cargo/config
%endif

%ifarch x86_64
sed -i '/\[build\]/a target="x86_64-unknown-linux-musl"' ./.cargo/config
%endif

sed -i '/\[source.crates-io\]/{n;d}' ./.cargo/config
sed -i '/\[source.local-registry\]/{n;d}' ./.cargo/config
sed -i '/\[source.local-registry\]/a directory = "vendor"' ./.cargo/config
%ifarch aarch64
sed -i 's/rustflags = \[/rustflags = \["-Clink-arg=-lgcc", /g' ./.cargo/config
%endif

%cargo_build -a

%install
%cargo_install -a
chmod 555 ${RPM_BUILD_ROOT}/usr/bin/stratovirt
chmod 555 ${RPM_BUILD_ROOT}/usr/bin/ozone

%changelog
* Tue Nov 29 2022 Xinle.Guo <guoxinle1@huawei.com> - 2.1.0-8
- Add micro vm seccomp rules

* Thu Nov 24 2022 yezengruan <yezengruan@huawei.com> - 2.1.0-7
- Update stratovirt download url

* Sun Oct 09 2022 yezengruan <yezengruan@huawei.com> - 2.1.0-6
- Unified license name specification

* Wed Mar 16 2022 zhouli57 <zhouli57@huawei.com> - 2.1.0-5
- Clear some warnings.

* Sun Mar 13 2022 Jie Yang <yangjieyj.yang@huawei.com> - 2.1.0-4
- Some bug fixes.
- Eliminate build warnings and clippy errors with Rust 1.57.0.
- Update docs.

* Tue Mar 01 2022 Jie Yang <yangjieyj.yang@huawei.com> - 2.1.0-3
- Fix memory snapshot failure with hotplugged devices.
- Fix address translation for virtio devices.
- Add some test cases for microvm.
- Update some documents.

* Fri Feb 18 2022 Jie Yang <yangjieyj.yang@huawei.com> - 2.1.0-2
- Fix VFIO hotplugging failure caused by missing seccomp rules.
- Fix booting failure from disk image on x86_64.
- Update some documents.

* Fri Feb 11 2022 Jie Yang <yangjieyj.yang@huawei.com> - 2.1.0-1
- Add support for PCIe native hotplugging.
- Reduce memory consumption of reading edk2 firmware files on aarch64.
- Add support for booting from disk image directly.
- Add support for VM reboot and VM shutdown.
- Add support for guest memory preallocation.
- Add more test cases.
- Add and fix documentation.
- Replace lazy_static crate with once_cell.
- Performance enhancement for virtio-blk and virtio-net devices.
- Add ftrace support.

* Mon Aug 30 2021 Jie Yang <yangjieyj.yang@huawei.com> - 2.0.0-6
- docs: fix some statement
- machine_manager: add autodeflate for balloon
- migration: add dev_id into VirtioPciState when save and restore device state
- machine: fix more than one pcie-root-ports with same id
- migration: move function "transport_reset" to save state stage for vhost vsock device
- vfio: adding ram device region to vfio bar region
- machine_manager: move argument "serial" from -drive to -device virtio-blk-pci/device
- machine_manager: add multifunction for devices
- machine: add init_multifunction function to init multifunction
- machine: add realization for multifunction

* Tue Aug 24 2021 Ming Yang <yangming73@huawei.com> - 2.0.0-5
- add ozone in rpm package.

* Fri Aug 20 2021 Jie Yang <yangjieyj.yang@huawei.com> - 2.0.0-3
- virtio: fix dev_id initialization for virtio-pci and vfio device on aarch64 platform
- vfio: fix the problem of dma mapping failed
- syscall: add syscall "newfstatat" in x86_64-unknown-linux-gnu target
- kernel_config: update kernel config 5.10 on aarch64 platform
- machine/standard_vm: fix inappropriate file open permissions
- migration: fix an errors during the PL011 device state restore
- migration: fix an error during migration interface on aarch64
- fix spelling errors in project

* Wed Aug 18 2021 Xinle.Guo <guoxinle1@huawei.com> - 2.0.0-2
- switch stratovirt permission from 550 to 555

* Fri Aug 13 2021 Jie Yang <yangjieyj.yang@huawei.com> - 2.0.0-1
- add ACPI support
- add PCIe/PCI support
- add support for UEFI boot
- add virtio pci support
- provide standard type machine on x86_64 and aarch64
- add hot boot feature
- add VFIO support
- add initial support for being managed by libvirt

* Tue Jul 27 2021 XuFei <xufei30@huawei.com> - 0.3.0-5
- add fdt patches for musl compilation

* Wed Jun 16 2021 XuFei <xufei30@huawei.com> - 0.3.0-4
- add gcc dependency package

* Fri May 28 2021 XuFei <xufei30@huawei.com> - 0.3.0-3
- modify docs
- modify testcases
- clear clippy warnings for updating rust 1.51.0

* Sun Apr 25 2021 LiangZhang <zhangliang5@huawei.com> - 0.3.0-2
- add hydropper to package

* Sun Apr 25 2021 LiangZhang <zhangliang5@huawei.com> - 0.3.0-1
- update package to 0.3.0

* Wed Jan 13 2021 LiangZhang <zhangliang5@huawei.com> - 0.1.0-3
- update package to latest source

* Wed Jan 13 2021 XuFei <xufei30@huawei.com> - 0.1.0-2
- modify summary and description for spec

* Thu Jul 16 2020 Xu Yandong <xuyandong2@huawei.com> - 0.1.0-1
- initial package
